import java.util.LinkedList;

/*
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
Verwenden Sie die gegebenen Testklassen zum Überprüfen Ihrer Lösung. Die Korrektheit dieser Testfälle
ist notwendig, aber nicht hinreichend für eine korrekte Lösung. Es werden damit nur bestimmte
Spezialfälle geprüft. Liefern die Testklassen keinen Fehler, garantiert dies noch nicht die
Korrektheit Ihrer Lösung gemäß der Angabe.
*/
public class Aufgabe1 {

    /*
    Aufgabe: Umgang mit Klassen und Objekten, sowie vorgefertigten Datenstrukturen.

        Ergänzen Sie fehlende Teile der Klassen 'Point' und 'Plane' entsprechend den Kommentaren
        an den mit TODO gekennzeichneten Stellen.

    Punkte (maximal 40):
        10 Punkte in Summe für Klasse 'Point':
            3 Punkte für Konstruktoren,
            1 Punkt für 'moveHorizontal',
            3 Punkte für 'toString',
            3 Punkte für 'equals' und 'hashCode',
        30 Punkte in Summe für Klasse 'Plane':
            4 Punkte für den Konstruktor
            5 Punkte für 'add'
            6 Punkte für 'selectNearestTo'
            5 Punkte für 'selection'
            5 Punkte für 'moveSelection'
            5 Punkte für 'toString'

    Auch für teilweise korrekte Lösungen werden Punkte vergeben.

    */
    


    // Diese Methode können Sie zum Testen nutzen. Sie geht nicht in die Beurteilung ein.
    public static void main(String[] args)
    {
        /*
        //Testen von Point:
        Point p = new Point(-1,2);
        System.out.println(p);
        System.out.println();

        for (int x = -5; x < 5; x++) {
            for (int y = -5; y < 5; y++) {
                if ((x == -1 && y == 2) != new Point(x,y).equals(p)) {
                    System.out.println("Fehler in Klasse 'Point'!");
                }
            }
        }

        //Testen von Plane:
        Plane plane = new Plane();

        plane.add(new Point(1,2));
        plane.add(new Point(2,0));
        plane.add(new Point(2,2));
        plane.add(new Point(0,2));
        plane.add(new Point(2,1));

        plane.selectNearestTo(new Point(0,0));

        System.out.println(plane.selection());
        System.out.println();

        System.out.println(plane);

       plane.moveSelection(5);

        System.out.println(plane);
        /* Erwartete Ausgabe:

        (-1,2)

        (0,2)

        (1,2)
        (2,0)
        (2,2)
        [(0,2)]
        (2,1)

        (1,2)
        (2,0)
        (2,2)
        [(5,2)]
        (2,1)

        */
        Plane plane = new Plane();

        plane.add(new Point(1,2));
        plane.add(new Point(2,0));
        plane.add(new Point(2,2));
        plane.add(new Point(0,2));
        plane.add(new Point(2,1));
        plane.selectNearestTo(new Point(0,0));

        System.out.println(plane);
    }
}

// Diese Klasse repräsentiert einen 2D-Punkt mit 2 Koordinaten in der Ebene.
class Point
{
    //TODO: Deklarieren Sie entsprechende Variablen.
    private int x, y;

    // Konstruktor Initialisiert diesen Punkt mit seinen Koordinaten.
    public Point(int x, int y)
    {
        this.x = x;
        this.y = y;
    }

    // Initialisiert diesen Punkt mit den Koordinaten von p.
    public Point(Point p)
    {
        this.x = p.x;
        this.y = p.y;
    }


    // Verschiebt diesen Punkt waagrecht, d.h. addiert 'deltaX'
    // zur x-Koordinate.
    public void moveHorizontal(int deltaX)
    {
        this.x += deltaX;
    }

    // Liefert die Manhattan-Distanz zwischen diesem Punkt und einem
    // angegebenen Punkt p.
    public int distanceTo(Point p) {
        int deltaX = Math.abs(this.x - p.x);
        int deltaY = Math.abs(this.y - p.y);
        return deltaX + deltaY;
    }

    @Override
    // Liefert eine lesbare Repräsentation der Koordinaten des Punktes in
    // der Form:
    // (x,y)
    public String toString()
    {
        return "(" + this.x + "," + this.y + ")";
    }

    @Override
    // Die equals-Methode: Überprüft die Gleichheit im Bezug auf
    // Koordinaten mit einem angegebenen Objekt.
    public boolean equals(Object o)
    {
        if (o == null) {
            return false;
        }
        if (o.getClass() != Point.class) {
            return false;
        }
        Point p = (Point) o;

        // Die Koordinaten vergleichen
        return this.x == p.x && this.y == p.y;
    }

    @Override
    // Liefert den Hashcode dieser Position. Dieser entspricht
    // der y-Koordinate der Position.
    public int hashCode()
    {
        return this.y;
    }
}

// Diese Klasse repräsentiert die xy-Ebene in der Punkte gespeichert werden.
// Es kann ein einzelner Punkt der Ebene für nachfolgende Operationen ausgewählt werden.
class Plane
{
    // Eine Liste zum Speichern der Punkte.
    private LinkedList<Point> list;
    // Eine Referenz auf den ausgewählten Punkt (siehe 'selectNearestTo'). Ist zunächst null.
    private Point selection = null;

    // Konstruktor: initialisiert diese Ebene als leere Ebene ohne Punkte.
    public Plane()
    {
        this.list = new LinkedList<>();
    }


    // Konstruktor: initialisiert diese Ebene unabhängige
    // Kopie von 'plane', d.h. mit den kopierten Punkten
    // von 'plane'. Werden Punkte von 'plane' später verändert
    // (oder verschoben) wirkt sich das nicht auf diese Ebene aus
    // und umgekehrt.
    public Plane(Plane plane)
    {
        this();

        for (Point p : plane.list)
        {
            this.list.add(new Point(p));
        }
    }

    // Fügt der Ebene den angegebenen Punkt hinzu. Wenn
    // ein solcher Punkt bereits in der Ebene existiert,
    // wird er nicht hinzugefügt.
    // liefert true, wenn das Point-Objekt hinzugefügt
    // wurde, sonst false.
    public boolean add(Point point)
    {
        if(this.list.contains(point))
            return false;
        else
            this.list.add(point);

        return true;
    }

    // Macht dasselbe wie 'add(Point)', allerdings werden die Koordinaten
    // des hinzuzufügenden Punktes angegeben.
    // Nutzen Sie zur Implementierung 'add(Point)'.
    public boolean add(int x, int y)
    {
        return add(new Point(x, y));
    }


    // Wählt unter allen Punkten der Ebene jenen Punkt aus, der am nächsten
    // zum angegebenen Punkt liegt (geringste Distanz aufweist).
    // Falls es mehrere Punkte mit derselben minimalen Distanz gibt, wird der
    // zuletzt hinzugefügte Punkt mit minimaler Distanz gewählt. Die Ebene merkt sich
    // diesen Punkt als Auswahl (selection). Es kann nur eine Auswahl geben. Wird
    // 'selectNearestTo' wiederholt aufgerufen, wird daher die bisherige
    // Auswahl verworfen.
    public void selectNearestTo(Point point)
    {
        for (Point p : this.list)
        {
            if(this.selection == null)
                this.selection = p;

            if(p.equals(point))
                this.selection = point;
            else
            {
                if(p.distanceTo(point) <= this.selection.distanceTo(point))
                    this.selection = p;
            }
        }
    }

    // Liefert den zuletzt mit 'selectNearestTo' ausgewählten Punkt. Wurde
    // noch kein Punkt selektiert, wird 'null' zurückgeliefert.
    public Point selection() {
        return this.selection;
    }

    // Verschiebt den ausgewählten Punkt waagrecht,
    // d.h. erhöht seine x-Koordinate um 'deltaX'.
    public void moveSelection(int deltaX)
    {
        this.selection.moveHorizontal(deltaX);
    }

    @Override
    // Liefert eine lesbare Repräsentation, in der jeder Punkt in einer
    // eigenen Zeile dargestellt wird. Der zuletzt ausgewählte Punkt wird
    // dabei in eckigen Klammern dargestellt. Die Reihenfolge der Punkte
    // in der Ausgabe ist beliebig.
    public String toString()
    {
        String ret = "";

        for (Point p : this.list)
        {
            if(p.equals(selection))
                ret += ("["+p.toString()+"]") + "\n";
            else
                ret += (p.toString()) + "\n";
        }

        return ret;
    }
}