/*
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
Verwenden Sie die gegebenen Testklassen zum Überprüfen Ihrer Lösung. Die Korrektheit dieser Testfälle
ist notwendig, aber nicht hinreichend für eine korrekte Lösung. Es werden damit nur bestimmte
Spezialfälle geprüft. Liefern die Testklassen keinen Fehler, garantiert dies noch nicht die
Korrektheit Ihrer Lösung gemäß der Angabe.
*/

public class Aufgabe2 {

    /*
    Aufgabe:
        Objekte der Klasse List stellen verkettete Listen von ganzen Zahlen mit
        Knoten vom Typ ListNode dar.
        Ergänzen Sie fehlende Teile der Klasse entsprechend den Kommentaren an
        den mit TODO gekennzeichneten Stellen.
        Hinweis: Die Methode 'add' ist bereits vollständig vorgegeben.

    Punkte (maximal 20):
        7 Punkte für addLast,
        7 Punkte für sumEvenElements,
        6 Punkte für toString.
        Auch für teilweise korrekte Lösungen werden Punkte vergeben.
    */

    // just for testing ...
    public static void main(String[] args)
    {
        /*
        // Implementierung von main wird nicht beurteilt
        List myList = new List();
        myList.add(5);
        myList.add(1);
        myList.add(9);
        myList.add(3);
        myList.add(6);
        myList.add(5);
        System.out.println(myList); //[->9->6->5->5->3->1-|]
        System.out.println();

        System.out.println("Check leere Liste");
        List myEmptyList = new List();
        System.out.println(myEmptyList); //[-|]
        System.out.println();

        System.out.println("Check addLast");
        List myTestAddLast = new List();
        myTestAddLast.addLast(8);
        myTestAddLast.addLast(4);
        System.out.println(myTestAddLast); // [->4->8-|]
        System.out.println();

        System.out.println("Check sumEvenElements");
        System.out.println(myEmptyList.sumEvenElements()); // -1
        System.out.println(myList.sumEvenElements()); // 6
        */
        List l = new List();

        l.add(1);
        l.add(3);
        l.add(5);
        l.add(5);
        l.add(6);
        l.add(9);

        System.out.println(l);
    }
}

// Repräsentiert einen Listenknoten. Wird von List benötigt.
class ListNode {

    // Keine zusätzlichen Variablen definieren.
    int elem;
    ListNode next = null;

    // Den Konstruktor nicht verändern.
    ListNode(int elem, ListNode next) {
        this.elem = elem;
        this.next = next;
    }

    // Rekursive Hilfsmethode für 'add' von 'List'.
    void add(int elem) {
        if (this.next == null) {
            this.next = new ListNode(elem, null);
        } else {
            if(this.next.elem >= elem ) {
                this.next = new ListNode(elem,this.next);
            }
            else{
                this.next.add(elem);
            }
        }
    }

    // Rekursive Hilfsmethode für 'addLast' von 'List'.
    public void addLast(int elem)
    {
        if(this.next != null)
            this.next.addLast(elem);
        else
            this.next = new ListNode(elem, null);
    }

    // Rekursive Hilfsmethode für 'toString' von 'List'.
    @Override
    public String toString()
    {
        String s = "";

        if(null != this.next)
            s += this.next.toString() + "->" + this.elem;
        else
            s+= "->" + this.elem;

        return s;
    }
}

// Repräsentiert eine Liste mit int-Werten.
class List {
    // Zeiger auf den Kopf der Liste. Bitte nicht verändern, oder zusätzliche
    // Variablen hinzufügen.
    private ListNode head = null;

    // Überprüft ob die Liste leer ist (Bitte nicht verändern).
    public boolean empty() {
        return this.head == null;
    }

    // Fügt neue Elemente aufsteigend sortiert in die Liste ein.
    // z.B. Die Aufrufe: add(5); add(1); add(9); add(3); add(6); add(5);
    // --> ergeben folgende Liste:
    // 1 3 5 5 6 9
    public void add(int elem) {
        if (this.empty()) {
            this.head = new ListNode(elem, null);
        } else {
            if(this.head.elem >= elem) {
                this.head = new ListNode(elem,this.head);
            }
            else {
                this.head.add(elem);
            }
        }
    }

    // Fügt das Element am Ende der Liste ein. "addLast" überprüft nicht,
    // ob nach dem Einfügen die Sortierung der Liste noch korrekt ist.
    public void addLast(int elem)
    {
        if(!this.empty())
            this.head.addLast(elem);
        else
            this.add(elem);
    }

    // Berechnet die Summe aller geraden Elemente und gibt die Summe zurück.
    // Bei einer leeren Liste wird -1 zurückgegeben.
    public int sumEvenElements()
    {
        int sum = 0;

        if(this.empty())
            return -1;
        else
        {
            ListNode curr = this.head;

            while (curr != null)
            {
                if(curr.elem%2 == 0)
                    sum += curr.elem;

                curr = curr.next;
            }
        }

        return sum;
    }

    // Retourniert alle Elemente der Liste in absteigender Reihenfolge
    // als String.
    // z.B. die Liste enthält 1, 3, 5, 5, 6 und 9, dann ist
    // das Ergebnis (exakte Formatierung beachten!):
    // "[->9->6->5->5->3->1-|]"
    //  [->9->6->5->5->3->1-|]
    // Für eine leere Liste wird "[-|]" zurückgegeben.
    @Override
    public String toString()
    {
        if(this.empty())
            return "[-|]";
        else
        {
            return "[" + this.head.toString() + "-|]";
        }
    }
}


